/****************************************************************************
2dbufsystem.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2dbufsystem.c,v 1.6 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

#include <sys/types.h>
#include <sys/mman.h>

#include "common.h"
#include "error_constants.h"
#include "nria_lib.h"



/*------------------------------------------------------------------------
mmap_buf_2d_rec - ???

if prot & 1  then PROT_READ
if prot & 2  then PROT_WRITE
if prot & 4  then PROT_EXEC
if prot & 8  then PROT_NONE
--------------------------------------------------------------------------*/

int
mmap_buf_2d_rec(_2d,prot,fid,off)
 struct buf_2d_rec *_2d;
 int prot;
 FILE *fid;
 off_t off;
{
 int intfd;
 int prot1;

 if (_2d->prog_status2 & BUF_DATA_MMAP) 
     return NO_ERROR;
 intfd = fileno(fid);

 prot1 = 0;
 if (prot & 1) prot1 |= PROT_READ;
 if (prot & 2) prot1 |= PROT_WRITE;
 if (prot & 4) prot1 |= PROT_EXEC;
 if (prot & 8) prot1 |= PROT_NONE;

 if ((int) mmap((caddr_t) _2d->buf[0],_2d->total_bytes, prot1,MAP_SHARED,intfd, off) == -1)
     return ~NO_ERROR;
 else
    {_2d->prog_status2 |= BUF_DATA_MMAP;
    return NO_ERROR;}
}

/*-----------------------------------------------------------------------
munmap_buf_2d_rec - ???
------------------------------------------------------------------------*/

int
munmap_buf_2d_rec(_2d)
 struct buf_2d_rec *_2d;
{
 if (!(_2d->prog_status2 & BUF_DATA_MMAP))
     return NO_ERROR;
 _2d->prog_status2 &= ~BUF_DATA_MMAP;
 if (munmap((caddr_t) _2d->buf[0],_2d->total_bytes) != 0)
     return ~NO_ERROR;
 else
     return NO_ERROR;
}
