/****************************************************************************
spm_hdr_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This rather looks like a half-finished project.  Don't trust it!
Fortunately, it doesn't seem to be used within NRIA.  -PWH 19990315
****************************************************************************/

static const char rcsid[] = "$Id: spm_hdr_opr.c,v 1.5 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <string.h>

#include <sys/types.h>

#include "error_constants.h"
#include "spm_hdr.h"
#include "mark_hdr.h"
#include "nria_lib.h"




/*---------------------------------------------------------------------------
init_spm_hdr_key - ???
---------------------------------------------------------------------------*/

void
init_spm_hdr_key(key)
 struct spm_hdr_key *key;
{
 key->size = sizeof(struct spm_hdr);
 strcpy(key->data_type,"\0");
 strcpy(key->name,"\0");
 key->extents = 0;
 key->session_error = 0;
 key->regular = ' ';
 key->hkey_un0 = ' ';
}


/*---------------------------------------------------------------------------
init_spm_hdr_history - ???
---------------------------------------------------------------------------*/

void
init_spm_hdr_history(history)
 struct spm_hdr_history *history;
{
 /* FIXME:  The string fields below should probably be filled with
    blanks or null, rather than just having the initial char set 
    to zero.  -PWH 19990315 */
 strcpy(history->descrip,"\0");
 strcpy(history->aux_file,"\0");
 history->orient = ' ';
 memset(history->origin,0,10);
 strcpy(history->generated,"\0");
 strcpy(history->scannum,"\0");
 strcpy(history->patient_id,"\0");
 strcpy(history->exp_date,"\0");
 strcpy(history->exp_time,"\0");
 strcpy(history->hist_un0,"\0");
 history->views = 0;
 history->vols_added = 0;
 history->start_field = 0;
 history->field_skip = 0;
 history->omax = 0;
 history->omin = 0;
 history->smax = 0;
 history->smin = 0;
}


/*---------------------------------------------------------------------------
init_spm_hdr_dimension - ???
---------------------------------------------------------------------------*/

void
init_spm_hdr_dimension(dimen)
 struct spm_hdr_dimension *dimen;
{
 dimen->num_dims = 4;
 dimen->dimx = 0;
 dimen->dimy = 0;
 dimen->max_slices = 0;
 dimen->num_vols = 1;
 dimen->histo_dimx = 0;
 dimen->histo_dimy = 0;
 dimen->status = 0;

 strcpy(dimen->vox_units,"\0");
 strcpy(dimen->cal_units,"\0");
 dimen->unused1 = 0;
 dimen->datatype = 0;

 dimen->pixel_depth_bits = 0;
 dimen->dim_un0 = 0;

 dimen->xpixel_size = 0;
 dimen->ypixel_size = 0;
 dimen->pixel_thickness = 0;
 dimen->spacing = 0;
 dimen->pixdim_unused1 = 0;
 dimen->pixdim_unused2 = 0;
 dimen->pixdim_unused3 = 0;
 dimen->pixdim_unused4 = 0;

 dimen->vox_offset = 0;
 dimen->funused1 = 0;
 dimen->funused2 = 0;
 dimen->funused3 = 0;
 dimen->cal_max = 0;
 dimen->cal_min = 0;
 dimen->compressed = 0;
 dimen->verified = 0;

 dimen->glmax = 0;
 dimen->glmin = 0;

}


/*---------------------------------------------------------------------------
init_spm_hdr - ???
---------------------------------------------------------------------------*/

void
init_spm_hdr(hdr)
 struct spm_hdr *hdr;
{
 init_spm_hdr_key(&(hdr->key));
 init_spm_hdr_history(hdr->history);
 init_spm_hdr_dimension(&(hdr->dimen));
}


/*---------------------------------------------------------------------------
rd_the_spm_hdr - ???
---------------------------------------------------------------------------*/

int
rd_the_spm_hdr(fn,spm)
 char *fn;
 struct spm_hdr *spm;
{
 FILE *fid;

 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;

 if (fread(spm,sizeof(struct spm_hdr),1,fid) != 1)
    {
     fclose(fid);
     printf("%s is a BAD DATA SPM HDR FILE !!!",fn);
     return READ_ERROR;}
 fclose(fid);
 return NO_ERROR;
}



/*---------------------------------------------------------------------------
wr_the_spm_hdr - ???
---------------------------------------------------------------------------*/

int
wr_the_spm_hdr(fn,spm)
 char *fn;
 struct spm_hdr *spm;
{
 FILE *fid;
 int err;

/*
 if ((fid = fopen(fn,"w","rfm=udf")) == NULL)
*/
 if ((fid = fopen(fn,"w")) == NULL)
    {
     return FILE_ACCESS_ERROR;}

 if (fwrite(spm,(size_t) sizeof(struct spm_hdr),1,fid) != 1)
    {fclose(fid);
     delete_file(fn);
     return err;}     /* FIXME:  err has not been initialized */
 fclose(fid);
 return NO_ERROR;

}


/*---------------------------------------------------------------------------
mark_to_spm_hdr_history - ???
---------------------------------------------------------------------------*/

void
mark_to_spm_hdr_history(mark,spm)
 struct mark_hdr_history *mark;
 struct spm_hdr_history *spm;
{
    /* FIXME:  No code here */
}


/*---------------------------------------------------------------------------
def_spm_hdr_dimension - ???
---------------------------------------------------------------------------*/

void
def_spm_hdr_dimension(spm)
 struct spm_hdr_dimension *spm;
{
 strcpy(spm->vox_units,"mm\0");
 spm->num_dims = 4;
 spm->num_vols = 3;
 spm->compressed = 0;
 spm->unused1 = 0;
 spm->unused1 = 0;
 spm->datatype = 2;
 spm->dim_un0 = 0;
 spm->pixdim_unused1 = .0;
 spm->pixdim_unused2 = .0;
 spm->pixdim_unused3 = .0;
 spm->pixdim_unused4 = .0;

 spm->vox_offset = .0;
 spm->cal_max = .0;
 spm->cal_min = .0;
 spm->verified = .0;
 spm->funused1 = .0;
 spm->funused2 = .0;
 spm->funused3 = .0;
}

/***********************
mark_hdr_to_spm_hdr(mark,spm)
 struct mark_hdr *mark;
 struct spm_hdr *spm;
{
 *spm = *mark;
 mark_to_spm_hdr_dimension(&(mark->dimen),&(spm->dimen));
}
*************************/
