
#include "lib/mri_format.h"
#include <xview/notify.h>
#include <sys/timeb.h>
/*
cc -c analysis_opr.c
*/
/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)

/*
AnalyzePixelTypes(anal,slice_roi,pixel_type,format,slice_map)

*/
exit_pixel_type_cnt_rec();
next_func();
struct roi_rec *get_roi();

AnalyzePixelTypes(anal,slice_roi,pixel_type,format,slice_map)
 struct analysis_rec *anal;
 struct slice_roi_rec *slice_roi;
 struct pixel_type_rec *pixel_type;
 struct output_text_format_rec *format;
 struct buf_2d_rec *slice_map;
{
 struct int_bound_rec affected;
 unsigned_int cnt,indx,roi_indx,lcv;
 struct pixel_type_cnt_rec *ptr;
 char slice_num_str[10];
 int err1,err;
 char *str;
 struct roi_rec *roi;

 TRACE(printf("AnalyzePixelTypes...begin\n"))

 if (slice_roi->num_rois == 0) return NO_ERROR;
 init_common_pixel_rec_matrix(&(anal->common),0);

 anal->_2d_ptr = NULL;
 for (cnt = 0; cnt < format->roi_labels.num_strs; cnt++)
    {roi_indx = format->roi_nums[cnt];
     if (roi_indx == 0) continue;
     if ((roi = get_roi(slice_roi,format->roi_labels.strs[cnt])) == NULL)
        continue;

     TRACE(printf("s#%d %d) label = %s roi_indx = %d\n",
            anal->next_slice_num,cnt,roi->label,roi_indx))

     if (roi->user.ptr == NULL)
        {roi->user.exit = exit_pixel_type_cnt_rec;
         if ((anal->err = setup_pixel_type_cnt_rec(&(roi->user.ptr),
                     &pixel_type)) != NO_ERROR)
            break;
        }
     ptr = (struct pixel_type_cnt_rec *) roi->user.ptr;
     if (anal->_2d_ptr == NULL)
        {anal->_2d_ptr = slice_map;
/*
         for (lcv = 0; lcv <= pixel_type->order.num_strs + 1; lcv++)
                {printf("%d) cnt = %d\n",lcv,cnt_val_buf_2d_rec(anal->_2d_ptr,
                            lcv));}
*/
        }
     TRACE(printf("...anal->_2d_ptr = %u num_pixel_type_cnts = %d\n",
                       anal->_2d_ptr,
                       ptr->num_pixel_type_cnts))
     if (((anal->err = get_filled_roi_mask(NULL,roi,
                        &(anal->mask),&affected)) != NO_ERROR) ||
         ((anal->err = cnt_pixel_types_by_mask(anal->_2d_ptr,
                        &(anal->mask.mask._2d),&affected,
                         ptr->pixel_type_cnts,ptr->num_pixel_type_cnts))
                          != NO_ERROR) ||
         ((anal->err = add_global_pixel_rec_matrix_by_mask(
                      &(anal->common),
                      &(anal->mask.mask._2d),&affected,
                      anal->_2d_ptr,roi_indx)) 
                     != NO_ERROR))
         break;

     ptr->status |= PIXEL_TYPE_CNTS_COMPUTED;
    }
 TRACE(printf("set_common_pixel_rec_matrix...err = %d\n",anal->err))

 if (anal->err == NO_ERROR)
    {anal->err = correct_slice_counts(anal,format,slice_roi);
         TRACE(printf("after correct_slice_counts...err = %d\n",anal->err))}
 if (anal->err != NO_ERROR)
    unset_slice_counts(slice_roi,format,cnt);
   else 
    {
/*
     for (cnt = 0; cnt < format->roi_labels.num_strs; cnt++)
        {
         if (format->roi_nums[cnt] == 0) continue;
         if ((roi = get_roi(slice_roi,format->roi_labels.strs[cnt])) == NULL)
            continue;
                     
         ptr = (struct pixel_type_cnt_rec *) roi->user.ptr;
         if (ptr == NULL) continue;
         for (lcv = 0; lcv < ptr->num_pixel_type_cnts; lcv++)
            printf("%d) %s roi_indx = %d cnt = %d\n",
                 lcv,roi->label,format->roi_nums[cnt],
         ptr->pixel_type_cnts[lcv]);
        }
*/
     }
 TRACE(printf("*****err = %d\n",anal->err))

 return anal->err;

}

