/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

#ifndef DEBUG_H
#define DEBUG_H

extern int debugFlag;
extern int abortFlag;

#ifdef DEBUG
#  define TRACE(x) \
	if (debugFlag) \
	{ \
	  x; \
	  fflush(stdout); \
	}
#  define PRT(x) \
	if (debugFlag) \
	{ \
	  x; \
	  fflush(stdout); \
	}
#  define PRT1(x) \
	if (debugFlag) \
	{ \
	  x; \
	  fflush(stdout); \
	}
#  define PRT2(x) \
	if (debugFlag) \
	{ \
	  x; \
	  fflush(stdout); \
	}
#  define PRT3(x) \
	if (debugFlag) \
	{ \
	  x; \
	  fflush(stdout); \
	}
#else
#  define TRACE(x)
#  define PRT(x)
#  define PRT1(x)
#  define PRT2(x)
#  define PRT3(x)
#endif

#define NOPRT(x) 

#endif DEBUG_H
