/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This header file defines object code and ought to be converted into
an ordinary source file.
****************************************************************************/


#ifndef RIA_GLOBAL_H
#define	RIA_GLOBAL_H

struct ByteBitOrder_rec
    {unsigned char num1bits;
     unsigned char bits[8];
    };

static struct ByteBitOrder_rec ByteBitOrder[256] =
   {
     {0,{0}},
     {1,{7}},
     {1,{6}},
     {2,{6, 7}},
     {1,{5}},
     {2,{5, 7}},
     {2,{5, 6}},
     {3,{5, 6, 7}},
     {1,{4}},
     {2,{4, 7}},
     {2,{4, 6}},
     {3,{4, 6, 7}},
     {2,{4, 5}},
     {3,{4, 5, 7}},
     {3,{4, 5, 6}},
     {4,{4, 5, 6, 7}},
     {1,{3}},
     {2,{3, 7}},
     {2,{3, 6}},
     {3,{3, 6, 7}},
     {2,{3, 5}},
     {3,{3, 5, 7}},
     {3,{3, 5, 6}},
     {4,{3, 5, 6, 7}},
     {2,{3, 4}},
     {3,{3, 4, 7}},
     {3,{3, 4, 6}},
     {4,{3, 4, 6, 7}},
     {3,{3, 4, 5}},
     {4,{3, 4, 5, 7}},
     {4,{3, 4, 5, 6}},
     {5,{3, 4, 5, 6, 7}},
     {1,{2}},
     {2,{2, 7}},
     {2,{2, 6}},
     {3,{2, 6, 7}},
     {2,{2, 5}},
     {3,{2, 5, 7}},
     {3,{2, 5, 6}},
     {4,{2, 5, 6, 7}},
     {2,{2, 4}},
     {3,{2, 4, 7}},
     {3,{2, 4, 6}},
     {4,{2, 4, 6, 7}},
     {3,{2, 4, 5}},
     {4,{2, 4, 5, 7}},
     {4,{2, 4, 5, 6}},
     {5,{2, 4, 5, 6, 7}},
     {2,{2, 3}},
     {3,{2, 3, 7}},
     {3,{2, 3, 6}},
     {4,{2, 3, 6, 7}},
     {3,{2, 3, 5}},
     {4,{2, 3, 5, 7}},
     {4,{2, 3, 5, 6}},
     {5,{2, 3, 5, 6, 7}},
     {3,{2, 3, 4}},
     {4,{2, 3, 4, 7}},
     {4,{2, 3, 4, 6}},
     {5,{2, 3, 4, 6, 7}},
     {4,{2, 3, 4, 5}},
     {5,{2, 3, 4, 5, 7}},
     {5,{2, 3, 4, 5, 6}},
     {6,{2, 3, 4, 5, 6, 7}},
     {1,{1}},
     {2,{1, 7}},
     {2,{1, 6}},
     {3,{1, 6, 7}},
     {2,{1, 5}},
     {3,{1, 5, 7}},
     {3,{1, 5, 6}},
     {4,{1, 5, 6, 7}},
     {2,{1, 4}},
     {3,{1, 4, 7}},
     {3,{1, 4, 6}},
     {4,{1, 4, 6, 7}},
     {3,{1, 4, 5}},
     {4,{1, 4, 5, 7}},
     {4,{1, 4, 5, 6}},
     {5,{1, 4, 5, 6, 7}},
     {2,{1, 3}},
     {3,{1, 3, 7}},
     {3,{1, 3, 6}},
     {4,{1, 3, 6, 7}},
     {3,{1, 3, 5}},
     {4,{1, 3, 5, 7}},
     {4,{1, 3, 5, 6}},
     {5,{1, 3, 5, 6, 7}},
     {3,{1, 3, 4}},
     {4,{1, 3, 4, 7}},
     {4,{1, 3, 4, 6}},
     {5,{1, 3, 4, 6, 7}},
     {4,{1, 3, 4, 5}},
     {5,{1, 3, 4, 5, 7}},
     {5,{1, 3, 4, 5, 6}},
     {6,{1, 3, 4, 5, 6, 7}},
     {2,{1, 2}},
     {3,{1, 2, 7}},
     {3,{1, 2, 6}},
     {4,{1, 2, 6, 7}},
     {3,{1, 2, 5}},
     {4,{1, 2, 5, 7}},
     {4,{1, 2, 5, 6}},
     {5,{1, 2, 5, 6, 7}},
     {3,{1, 2, 4}},
     {4,{1, 2, 4, 7}},
     {4,{1, 2, 4, 6}},
     {5,{1, 2, 4, 6, 7}},
     {4,{1, 2, 4, 5}},
     {5,{1, 2, 4, 5, 7}},
     {5,{1, 2, 4, 5, 6}},
     {6,{1, 2, 4, 5, 6, 7}},
     {3,{1, 2, 3}},
     {4,{1, 2, 3, 7}},
     {4,{1, 2, 3, 6}},
     {5,{1, 2, 3, 6, 7}},
     {4,{1, 2, 3, 5}},
     {5,{1, 2, 3, 5, 7}},
     {5,{1, 2, 3, 5, 6}},
     {6,{1, 2, 3, 5, 6, 7}},
     {4,{1, 2, 3, 4}},
     {5,{1, 2, 3, 4, 7}},
     {5,{1, 2, 3, 4, 6}},
     {6,{1, 2, 3, 4, 6, 7}},
     {5,{1, 2, 3, 4, 5}},
     {6,{1, 2, 3, 4, 5, 7}},
     {6,{1, 2, 3, 4, 5, 6}},
     {7,{1, 2, 3, 4, 5, 6, 7}},
     {1,{0}},
     {2,{0, 7}},
     {2,{0, 6}},
     {3,{0, 6, 7}},
     {2,{0, 5}},
     {3,{0, 5, 7}},
     {3,{0, 5, 6}},
     {4,{0, 5, 6, 7}},
     {2,{0, 4}},
     {3,{0, 4, 7}},
     {3,{0, 4, 6}},
     {4,{0, 4, 6, 7}},
     {3,{0, 4, 5}},
     {4,{0, 4, 5, 7}},
     {4,{0, 4, 5, 6}},
     {5,{0, 4, 5, 6, 7}},
     {2,{0, 3}},
     {3,{0, 3, 7}},
     {3,{0, 3, 6}},
     {4,{0, 3, 6, 7}},
     {3,{0, 3, 5}},
     {4,{0, 3, 5, 7}},
     {4,{0, 3, 5, 6}},
     {5,{0, 3, 5, 6, 7}},
     {3,{0, 3, 4}},
     {4,{0, 3, 4, 7}},
     {4,{0, 3, 4, 6}},
     {5,{0, 3, 4, 6, 7}},
     {4,{0, 3, 4, 5}},
     {5,{0, 3, 4, 5, 7}},
     {5,{0, 3, 4, 5, 6}},
     {6,{0, 3, 4, 5, 6, 7}},
     {2,{0, 2}},
     {3,{0, 2, 7}},
     {3,{0, 2, 6}},
     {4,{0, 2, 6, 7}},
     {3,{0, 2, 5}},
     {4,{0, 2, 5, 7}},
     {4,{0, 2, 5, 6}},
     {5,{0, 2, 5, 6, 7}},
     {3,{0, 2, 4}},
     {4,{0, 2, 4, 7}},
     {4,{0, 2, 4, 6}},
     {5,{0, 2, 4, 6, 7}},
     {4,{0, 2, 4, 5}},
     {5,{0, 2, 4, 5, 7}},
     {5,{0, 2, 4, 5, 6}},
     {6,{0, 2, 4, 5, 6, 7}},
     {3,{0, 2, 3}},
     {4,{0, 2, 3, 7}},
     {4,{0, 2, 3, 6}},
     {5,{0, 2, 3, 6, 7}},
     {4,{0, 2, 3, 5}},
     {5,{0, 2, 3, 5, 7}},
     {5,{0, 2, 3, 5, 6}},
     {6,{0, 2, 3, 5, 6, 7}},
     {4,{0, 2, 3, 4}},
     {5,{0, 2, 3, 4, 7}},
     {5,{0, 2, 3, 4, 6}},
     {6,{0, 2, 3, 4, 6, 7}},
     {5,{0, 2, 3, 4, 5}},
     {6,{0, 2, 3, 4, 5, 7}},
     {6,{0, 2, 3, 4, 5, 6}},
     {7,{0, 2, 3, 4, 5, 6, 7}},
     {2,{0, 1}},
     {3,{0, 1, 7}},
     {3,{0, 1, 6}},
     {4,{0, 1, 6, 7}},
     {3,{0, 1, 5}},
     {4,{0, 1, 5, 7}},
     {4,{0, 1, 5, 6}},
     {5,{0, 1, 5, 6, 7}},
     {3,{0, 1, 4}},
     {4,{0, 1, 4, 7}},
     {4,{0, 1, 4, 6}},
     {5,{0, 1, 4, 6, 7}},
     {4,{0, 1, 4, 5}},
     {5,{0, 1, 4, 5, 7}},
     {5,{0, 1, 4, 5, 6}},
     {6,{0, 1, 4, 5, 6, 7}},
     {3,{0, 1, 3}},
     {4,{0, 1, 3, 7}},
     {4,{0, 1, 3, 6}},
     {5,{0, 1, 3, 6, 7}},
     {4,{0, 1, 3, 5}},
     {5,{0, 1, 3, 5, 7}},
     {5,{0, 1, 3, 5, 6}},
     {6,{0, 1, 3, 5, 6, 7}},
     {4,{0, 1, 3, 4}},
     {5,{0, 1, 3, 4, 7}},
     {5,{0, 1, 3, 4, 6}},
     {6,{0, 1, 3, 4, 6, 7}},
     {5,{0, 1, 3, 4, 5}},
     {6,{0, 1, 3, 4, 5, 7}},
     {6,{0, 1, 3, 4, 5, 6}},
     {7,{0, 1, 3, 4, 5, 6, 7}},
     {3,{0, 1, 2}},
     {4,{0, 1, 2, 7}},
     {4,{0, 1, 2, 6}},
     {5,{0, 1, 2, 6, 7}},
     {4,{0, 1, 2, 5}},
     {5,{0, 1, 2, 5, 7}},
     {5,{0, 1, 2, 5, 6}},
     {6,{0, 1, 2, 5, 6, 7}},
     {4,{0, 1, 2, 4}},
     {5,{0, 1, 2, 4, 7}},
     {5,{0, 1, 2, 4, 6}},
     {6,{0, 1, 2, 4, 6, 7}},
     {5,{0, 1, 2, 4, 5}},
     {6,{0, 1, 2, 4, 5, 7}},
     {6,{0, 1, 2, 4, 5, 6}},
     {7,{0, 1, 2, 4, 5, 6, 7}},
     {4,{0, 1, 2, 3}},
     {5,{0, 1, 2, 3, 7}},
     {5,{0, 1, 2, 3, 6}},
     {6,{0, 1, 2, 3, 6, 7}},
     {5,{0, 1, 2, 3, 5}},
     {6,{0, 1, 2, 3, 5, 7}},
     {6,{0, 1, 2, 3, 5, 6}},
     {7,{0, 1, 2, 3, 5, 6, 7}},
     {5,{0, 1, 2, 3, 4}},
     {6,{0, 1, 2, 3, 4, 7}},
     {6,{0, 1, 2, 3, 4, 6}},
     {7,{0, 1, 2, 3, 4, 6, 7}},
     {6,{0, 1, 2, 3, 4, 5}},
     {7,{0, 1, 2, 3, 4, 5, 7}},
     {7,{0, 1, 2, 3, 4, 5, 6}},
     {8,{0, 1, 2, 3, 4, 5, 6, 7}}
    };

#endif RIA_GLOBAL_H
