#include <stdio.h>
#include <string.h>
/*
#include <sys/types.h>
*/
#include "error_constants.h"
typedef unsigned int unsigned_int;

/*
cc -c rd_text.c
*/
/* used in rd_text.c  */
#define RD_TEXT 1
#define RD_INT  2
#define RD_FLOAT 3

/*
#define TRACE(x)
*/
#define TRACE(x) x; fflush(stdout);

/*
rd_text_text(fid,ary,tot,ok,str,indx,is_one_line)
rd_text_line(fid,str,len,maxlen)
def_rd_signed_int(fid,num,lb,ub,defnum)
range_rd_signed_int(fid,num,lb,ub,defnum)
def_rd_float(fid,num,lb,ub,defnum)
range_rd_float(fid,num,lb,ub,defnum)
get_text_int(str,indx,ary,tot,cnt,ok)
rd_text_int(fid,ary,tot,ok,str,indx)
get_text_float(str,indx,ary,tot,cnt,ok)
rd_text_float(fid,ary,tot,ok,str,indx)
rd_text(fid,ary,tot,ok,select)
rd_all_texts(fid,strs,num_strs)
rd_all_file_texts(fn,strs,num_strs)
rd_text_fields(fid,labels,num_labels)

wr_all_texts(fid,strs,num_strs)
wr_all_file_texts(fn,strs,num_strs)

wr_float_ary(fid,ary,elems)
wr_int_ary(fid,ary,elems)
wr_int2_ary(fid,ary,elems)

/*
clean_text_str(str,range,range_len,pad_ch)
 char *str,*range,pad_ch;
 unsigned short range_len;
{
 unsigned short cnt;
 unsigned_int len,indx;

 len = strlen(str);
 for (indx = 0; indx < len; indx++)
    for (cnt = 0; cnt < range_len; cnt+= 2)
       if ((str[indx] < range[cnt]) || (str[indx] > range[cnt+1]))
          {str[indx] = pad_ch;
           break;}

}
*/

rd_text_text(fid,ary,tot,ok,str,indx,is_one_line)
 FILE *fid;
 char *ary;
 unsigned_int *tot;
 int *ok;
 char str[256];
 unsigned_int *indx;
 int is_one_line;
{
 char *addr,*addr1;
 static char delimiter[] = {' ',9,'\n','\0'};
 unsigned_int len,len1;

 *ok = NO_ERROR;
 addr = NULL;
 if (*indx != 0) len1 = strlen(str);
 while ((*ok == NO_ERROR) && (addr == NULL))
    {
     if ((*indx == 0) && (fgets(str,255,fid) == NULL))
       {str[0] = '\0';
        *ok = END_OF_FILE;}
       else
        {if (*indx == 0)
            {len1 = strlen(str);
            }

         if ((addr = strchr(str,'#')) != 0)
            {addr[0] = '\0';
            }

         if ((((addr = strchr(str,'%')) != 0) &&
              ((addr1 = strchr(addr+1,'%')) != 0)) ||
             (((addr = strchr(str,'"')) != 0) &&
              ((addr1 = strchr(addr+1,'"')) != 0)))
            {addr += 1;
             addr1[0] = '\0';
	     }
           else
            {addr = strtok(&(str[*indx]),delimiter);
            }
         if (addr == NULL) *indx = 0;
        }
     if (is_one_line) break;
    }
 if ((*ok == NO_ERROR) && (addr != NULL))
    {len = strlen(addr);
     *indx = addr - str + len + 1;
     if (len >= *tot)
        {len = *tot - 1;
         strncpy(ary,addr,(size_t) len);
         ary[*tot] = '\0';}
       else strcpy(ary,addr);
     *tot = len;
     if (*indx >= len1) *indx = 0;
     }
   else if ((*ok != NO_ERROR) || (addr == NULL)) *tot = 0;
}

rd_text_line(fid,str,len,maxlen)
 FILE *fid;
 char *str;
 unsigned_int *len,maxlen;
{
#define STR_LEN 256
 char str1[STR_LEN];
 unsigned_int len1;
 int ok;

 *len = maxlen;
 len1 = 0;
 rd_text_text(fid,str,&len,&ok,str1,&len1,1); 
#undef STR_LEN
}

def_rd_signed_int(fid,num,lb,ub,defnum)
 FILE *fid;
 int *num,lb,ub,defnum;
{
 char str[30];
 unsigned_int len;

 rd_text_line(fid,str,&len,30);
 *num = defnum;
 sscanf(str,"%d",num);
 if ((*num < lb) || (*num > ub)) *num = defnum;
}

range_rd_signed_int(fid,num,lb,ub,defnum)
 FILE *fid;
 int *num,lb,ub,defnum;
{
 char str[30],str1[256];
 unsigned_int len,len1;
 int ok;

 len = sizeof(str);
 len1 = 0;
 rd_text_text(fid,str,&len,&ok,str1,&len1,0); 
 *num = defnum;
 if ((len == 0) || (ok != NO_ERROR)) return;
 sscanf(str,"%d",num);
 if ((*num < lb) || (*num > ub)) *num = defnum;
}

def_rd_float(fid,num,lb,ub,defnum)
 FILE *fid;
 float *num,lb,ub,defnum;
{
 char str[30];
 unsigned_int len;

 rd_text_line(fid,str,&len,30);
 *num = defnum;
 sscanf(str,"%f",num);
 if ((*num < lb) || (*num > ub)) *num = defnum;
}

range_rd_float(fid,num,lb,ub,defnum)
 FILE *fid;
 float *num,lb,ub,defnum;
{
 char str[30],str1[256];
 unsigned_int len,len1;
 int ok;

 len = sizeof(str);
 len1 = 0;
 rd_text_text(fid,str,&len,&ok,str1,&len1,0); 
 *num = defnum;
 if ((len == 0) || (ok != NO_ERROR)) return;
 sscanf(str,"%f",num);
 if ((*num < lb) || (*num > ub)) *num = defnum;
}

get_text_int(str,indx,ary,tot,cnt,ok)
 char *str;
 unsigned_int *indx;
 int *ary;
 unsigned_int tot,*cnt;
 int *ok;
{
 unsigned_int len;
 char done,*addr;
 static char delimiter[] = {' ',9,'\n','\0'};

 addr = strtok(&(str[*indx]),delimiter);		
 *ok = NO_ERROR;
 if (addr == NULL) *indx = 0;
   else
    {
     for (done = 0; !done && (*cnt < tot) && (addr != NULL);)
       {
        if ((*ok = sscanf(addr,"%d",&(ary[*cnt]))) == 1)
           {*cnt += 1;
            if (*cnt < tot) addr = strtok(NULL,delimiter);
            }
          else
           {done = 1;
            *indx = 0;
            if (*ok == EOF) *ok = NO_ERROR;
              else *ok = READ_ERROR;
           }
       }
     if (!done)
        {if (addr == NULL) *indx = 0;
           else
            {len = strlen(addr);
             *indx = addr - str + len + 1;}
         *ok = NO_ERROR;}
       else if (addr == NULL) *indx = 0;
       else if (*ok == NO_ERROR) *indx = addr - str + 1;
    }
}


rd_text_int(fid,ary,tot,ok,str,indx)
 FILE *fid;
 int *ary;
 unsigned_int *tot;
 int *ok;
 char str[256];
 unsigned_int *indx;
{
 unsigned_int len,cnt,len1;
 char *str1;

 *ok = NO_ERROR;
 cnt = 0;
 if (*indx != 0) len1 = strlen(str);
   else len1 = 0;
 while ((*ok == NO_ERROR) && (cnt < *tot))
    {if ((*indx >= len1) && (fgets(str,255,fid) == NULL))
       {str[0] = '\0';
        *ok = END_OF_FILE;
        *tot = cnt;}
       else
        {if (*indx >= len1)
            {*indx = 0;
             len1 = strlen(str);}
         if ((str1 = strchr(str,'#')) != 0) str1[0] = '\0';
         get_text_int(str,indx,ary,*tot,&cnt,ok);
         if (*indx == 0) len1 = 0;}
    }
 if (*indx >= len1) *indx = 0;
}

get_text_float(str,indx,ary,tot,cnt,ok)
 char *str;
 unsigned_int *indx;
 float *ary;
 unsigned_int tot,*cnt;
 int *ok;
{
 unsigned_int len;
 char done,*addr;
 static char delimiter[] = {' ',9,'\n','\0'};

 addr = strtok(&(str[*indx]),delimiter);		
 *ok = NO_ERROR;
 if (addr == NULL) *indx = 0;
   else
    {
     for (done = 0; !done && (*cnt < tot) && (addr != NULL);)
       {if ((*ok = sscanf(addr,"%e",&(ary[*cnt]))) == 1)
           {
            *cnt += 1;
            if (*cnt < tot) addr = strtok(NULL,delimiter);
            }
          else
           {done = 1;
            *indx = 0;
            if (*ok == EOF) *ok = NO_ERROR;
              else *ok = READ_ERROR;
           }
       }
     if (!done)
        {if (addr == NULL) *indx = 0;
           else
            {len = strlen(addr);
             *indx = addr - str + len + 1;}
         *ok = NO_ERROR;}
       else if (addr == NULL) *indx = 0;
       else if (*ok == NO_ERROR) *indx = addr - str + 1;
    }
}

rd_text_float(fid,ary,tot,ok,str,indx)
 FILE *fid;
 float *ary;
 unsigned_int *tot;
 int *ok;
 char str[256];
 unsigned_int *indx;
{
 unsigned_int len,cnt,len1;
 char *str1;

 *ok = NO_ERROR;
 cnt = 0;
 if (*indx != 0) len1 = strlen(str);
    else len1 = 0;
 while ((*ok == NO_ERROR) && (cnt < *tot))
    {if ((*indx >= len1) && (fgets(str,255,fid) == NULL))
       {str[0] = '\0';
        *ok = END_OF_FILE;
        *tot = cnt;}
       else
        {if (*indx >= len1)
            {*indx = 0;
/*             clean_text_str(str," ~",2,' '); */
             len1 = strlen(str);}
         if ((str1 = strchr(str,'#')) != 0) str1[0] = '\0';
         get_text_float(str,indx,ary,*tot,&cnt,ok);
         if (*indx == 0) len1 = 0;}
    }
 if (*indx >= len1) *indx = 0;
}

rd_text(fid,ary,tot,ok,select)
 FILE *fid;
 char *ary;
 unsigned_int *tot;
 int *ok;
 unsigned char select;
{
 static unsigned_int indx;
 static char str[256];
 static FILE *temp_fid = NULL;

 if ((temp_fid == NULL) || (temp_fid != fid))
    {temp_fid = fid;
     indx = 0;}

 if (select == RD_TEXT)
     rd_text_text(fid,ary,tot,ok,str,&indx,0);
    else if (select == RD_INT)
     rd_text_int(fid,ary,tot,ok,str,&indx);
    else if (select == RD_FLOAT)
     rd_text_float(fid,ary,tot,ok,str,&indx);

 if ((*ok == NO_ERROR) && (indx != 0))
    {
     str[0] = ' ';
     strcpy(&(str[1]),&(str[indx]));
     indx = 1;}
}

/*  Commented out because of incorrect code.  I made sure that none
 *  of the programs in this directory (teong/) use this routine.
 *  DRW 960203
 *  Specifically, drop_handle_element is only to be found in
 *  export/finalimg/ptr_and_dim.c, which needs to be recompiled.  There
 *  are problems with compiling that program, however, and so I need to
 *  work with nlib/ptr_and_dim.c which does not have drop_handle_element.
 */
#if 0
rd_all_texts(fid,strs,num_strs)
 FILE *fid;
 char ***strs;
 unsigned_int *num_strs;
{
 char str[256];
 unsigned_int len;
 int err;

 do
    {len = 256;
     rd_text(fid,str,&len,&err,RD_TEXT);
     if (err == 0)
        {get_handle_memory(strs,num_strs,(unsigned_int) 1,
                           (size_t) sizeof(char *),&err);
         if (err == NO_ERROR)
            if (copy_str(&((*strs)[*num_strs - 1]),str,(size_t) strlen(str))
                != NO_ERROR)
               {drop_handle_element(strs,num_strs,(*strs)[*num_strs - 1]);
                break;}
        }
    }
 while (err == 0);
 if (*num_strs == 0) return READ_ERROR;
   else return NO_ERROR;
}
#endif


rd_all_file_texts(fn,strs,num_strs)
 char *fn;
 char ***strs;
 unsigned_int *num_strs;
{
 FILE *fid;
 int err;

 *num_strs = 0;
 *strs = NULL;
 if (fn == NULL) return FILE_NAME_ERROR;
 if ((fid = fopen(fn,"r")) == NULL)
    {
     return FILE_ACCESS_ERROR;}
 err = rd_all_texts(fid,strs,num_strs);
 fclose(fid);
 return err;
}

rd_text_fields(fid,labels,num_labels)
 FILE *fid;
 char ***labels;
 unsigned_int *num_labels;
{
 unsigned_int total,num,cnt;
 char str[256];
 int err;

 total = 1;
 rd_text(fid,&num,&total,&err,RD_INT);
 if (err) return err;
 total = 0;
 get_ptr_memory(labels,&total,num,(size_t) sizeof(char *),&err);
 if (err) return err;
 *num_labels = num;

 for (cnt = 0; cnt < num; cnt++)
    {total = 255;
     rd_text(fid,str,&total,&err,RD_TEXT);
     if (err) return err;
     if ((err = cp_str(&((*labels)[cnt]),str)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}

wr_all_texts(fid,strs,num_strs)
 FILE *fid;
 char **strs;
 unsigned_int num_strs;
{
 unsigned_int lcv,len,blank_posi,blank;
 int err;

 for (lcv = 0; lcv < num_strs; lcv++)
    {len = get_strlen(strs[lcv]);
     if (len > 0)
        {if ((err = blank_in_str(strs[lcv],&blank_posi)) == NO_ERROR)
            {if (fprintf(fid,"\"%s\"\n",strs[lcv]) == 0)
                {printf("wr_all_texts 1...\n");
                 return WRITE_ERROR;}
            }
           else if (fprintf(fid,"%s\n",strs[lcv]) == 0)
            {
             return WRITE_ERROR;}
         }
        else if (fprintf(fid,"\n") == 0)
         {
          return WRITE_ERROR;}
    }
 return NO_ERROR;
}

wr_all_file_texts(fn,strs,num_strs)
 char *fn;
 char **strs;
 unsigned_int num_strs;
{
 FILE *fid;
 int err;

 if (fn == NULL) return FILE_NAME_ERROR;
 if ((fid = fopen(fn,"w")) == NULL)
    {
     return FILE_ACCESS_ERROR;}
 err = wr_all_texts(fid,strs,num_strs);
 fclose(fid);
 return err;

}

wr_float_ary(fid,ary,elems)
 FILE *fid;
 float *ary;
 unsigned_int elems;
{
 unsigned_int cnt;

 for (cnt = 0; cnt < elems; cnt++)
    {
     if (cnt % 5 == 0) fprintf(fid,"\n");
     fprintf(fid,"%e ",ary[cnt]);}
 fprintf(fid,"\n");
}

wr_int_ary(fid,ary,elems)
 FILE *fid;
 int *ary;
 unsigned_int elems;
{
 unsigned_int cnt;

 for (cnt = 0; cnt < elems; cnt++)
    {
     if (cnt % 5 == 0) fprintf(fid,"\n");
     fprintf(fid,"%d ",ary[cnt]);}
 fprintf(fid,"\n");
}

wr_int2_ary(fid,ary,elems)
 FILE *fid;
 short *ary;
 unsigned_int elems;
{
 unsigned_int cnt;

 for (cnt = 0; cnt < elems; cnt++)
    {
     if (cnt % 10 == 0) fprintf(fid,"\n");
     fprintf(fid,"%6d ",(int) ary[cnt]);}
 fprintf(fid,"\n");
}
/*
main()
{
 int indx;
 char str[80];
 unsigned_int len;
 char text[40];
 int ary[10];
 float rary[32];
 unsigned_int tot;
 int ok;
 FILE *fid;

 if ((fid = fopen("D1.dat","r","ctx=nocvt")) == NULL)
    {perror("error...");
     exit(1);}

 tot = 39;
 rd_text(fid,text,&tot,&ok,RD_TEXT);
 printf("tot = %d   ok = %d\n",(int) tot,(int)ok);
 if (ok == NO_ERROR) printf("text = %s",text);

 tot = 2;
 rd_text(fid,ary,&tot,&ok,RD_INT);
 wr_int_ary(stdout,ary,tot);
 tot = 32;
 rd_text(fid,rary,&tot,&ok,RD_FLOAT);
 printf("tot = %d   ok = %d\n",tot,ok);
 wr_float_ary(stdout,rary,tot);

 fclose(fid);
}

*/

