#include "mri_format.h"
/*
cc -c v3_rd_ria_dat.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT5(x)
/*
rd_str_value_rec(fid,str_value)
rd_str_value_recs(fid,str_values,num_str_values)

rd_output_hdr_info_rec(fid,info)
verify_dat_hdr(info,file,hdr_error_proc)
rd_output_slice_nums(fid,slice_nums,num_slice_rois)
rd_output_field_offset_rec(fid,offset)
rd_output_hdr_rec(fid,hdr,hdr_error_proc)
rd_output_slice_rois(fid,slice_rois,actual_total_slice_rois,
                     slice_nums,num_slice_rois)

rd_histo_pixel_center_recs(fid,centers,num_centers,slice_roi)

rd_histo_bkg_rec(fid,bkg)
rd_histo_params(fid,histo)
rd_pixel_type_cnt_rec(fid,pixel_cnt)
rd_roi_pixel_type_cnts(fid,slice_rois,num_slice_rois)
rd_pixel_type_params(fid,pixel_type)
rd_text_output_analysis_group_rec(fid,group)

rd_input_text_file_format(fid,groups,num_groups)
rd_output_field_rec(fid,group)
rd_output_count_field_rec(fid,group)
rd_output_count_group_rec(fid,count)
rd_output_text_file_format(fid,format)

rd_roi_count_anal_rec(fid,roi,is_new_format)
rd_slice_count_anal_rec(fid,slice)
rd_slice_count_anal_recs(fid,slices,total_slices,num_slices)
rd_count_analysis_rec(fid,count)

cp_dat_output_hdr_rec(hdr,output)
cp_dat_slice_roi_recs(slice_rois,slice_nums,num_slice_rois,
                      actual_total_slice_rois,file)
cp_nth_slice_roi_rec(slice_rois,slice_nums,num_slice_rois,file,slice_num)
cp_dat_histo_params_rec(histo,file)
cp_dat_pixel_type_rec(pixel_type,file)
cp_text_output_analysis_group_rec(groups,num_groups,file)
cp_output_text_format_rec(format,file)
cp_count_analysis_rec(count,file)

RdNdatFields(fid,hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)
free_ndat_fields(hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)
RdTheNdatFields(fn,hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)

rd_dat_file(fn,output)
rd_dat_file_slice_rois(fn,file)
rd_file_slice_roi_rec(fn,file,slice_num)
*/
struct roi_rec *get_roi();
/*
rd_str_value_rec(fid,str_value)
 FILE *fid;
 struct str_value_rec *str_value;
{
 int err;

 if ((err = rd_file_strs(fid,&(str_value->str),1)) != NO_ERROR)
    return err;
 if (fread(&(str_value->value),(size_t) sizeof(str_value->value),1,fid) != 1)
    return READ_ERROR;
 return NO_ERROR;
}

rd_str_value_recs(fid,str_values,num_str_values)
 FILE *fid;
 struct str_value_rec **str_values;
 unsigned long *num_str_values;
{
 unsigned long lcv;
 int err;

 if (fread(num_str_values,(size_t) sizeof(*num_str_values),1,fid) != 1)
    return READ_ERROR;
 if (*num_str_values == 0) return NO_ERROR;

 if ((err = get_ptr(str_values,NULL,*num_str_values,
       (size_t) sizeof(struct str_value_rec))) != NO_ERROR)
    *num_str_values = 0;
   else
    {for (lcv = 0; lcv < *num_str_values; lcv++)
        init_str_value_rec(&((*str_values)[lcv]));
     for (lcv = 0; lcv < *num_str_values; lcv++)
        if ((err = rd_str_value_rec(fid,&((*str_values)[lcv]))) != NO_ERROR)
           {
            free_str_value_rec_ary(*str_values,*num_str_values);
            *str_values = NULL;
            *num_str_values = 0;
            return err;}
    }

 return err;
}
*/

/*
 might need to compare the current info content with the info to be read
  from the input .dat file  in the future*/
/*
rd_output_hdr_info_rec(fid,info)
 FILE *fid;
 struct output_hdr_info_rec *info;
{
 int err;

 err = READ_ERROR;
 if (((err = rd_file_strs(fid,&(info->dirfn),1)) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->fn),1)) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->hdr_fn_suffix),1)) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(info->img_fn_suffix),1)) != NO_ERROR) ||
     (fread(&(info->dimx),(size_t) sizeof(info->dimx),1,fid) != 1) ||
     (fread(&(info->dimy),(size_t) sizeof(info->dimy),1,fid) != 1) ||
     (fread(&(info->max_slices),
            (size_t) sizeof(info->max_slices),1,fid) != 1) ||
     (fread(&(info->pixel_depth_bits),
            (size_t) sizeof(info->pixel_depth_bits),1,fid) != 1))
    return err;
 TRACE(printf("==> info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
       info->hdr_fn_suffix,info->img_fn_suffix))
 TRACE(printf("==> info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
       info->hdr_fn_suffix,info->img_fn_suffix))
 return NO_ERROR;
}

verify_dat_hdr(info,file,hdr_error_proc)
 struct output_hdr_info_rec *info;
 struct input_file_rec *file;
 int (*hdr_error_proc)();
{
 return NO_ERROR;
}
*/
rd_output_slice_nums(fid,slice_nums,num_slice_rois)
 FILE *fid;
 unsigned_int **slice_nums;
 unsigned_int *num_slice_rois;
{
 int err;

 TRACE(printf("rd_output_slice_nums...*num_slice_rois = %d\n",*num_slice_rois))

 if (*num_slice_rois == 0) return NO_ERROR;
 if ((err = get_ptr(slice_nums,NULL,*num_slice_rois,
           (size_t) sizeof(**slice_nums))) != NO_ERROR)
    {*num_slice_rois = 0;
     return err;}
  
 if (fread(*slice_nums,(size_t) (sizeof(**slice_nums) * (*num_slice_rois)),
              1,fid) != 1)
    {return READ_ERROR;}
 TRACE(printf("rd_output_slice_nums..end\n"))

 return NO_ERROR;

}

rd_output_field_offset_rec(fid,offset)
 FILE *fid;
 struct output_field_offset_rec *offset;
{
 if (fread(&(offset->slice_roi_start),40,1,fid) != 1)
    return READ_ERROR;
 return NO_ERROR;
}

rd_output_hdr_rec(fid,hdr,hdr_error_proc)
 FILE *fid;
 struct output_hdr_rec *hdr;
 int (*hdr_error_proc)();
{
 int err;

 err = READ_ERROR;
 if ((fread(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
     ((err = rd_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = rd_file_strs(fid,&(hdr->rater),1)) == NO_ERROR) &&
     ((err = rd_output_field_offset_rec(fid,&(hdr->offset))) == NO_ERROR))
    {
     if (str_cmp(hdr->id,DAT_ID_V3) != 0)
        {printf("Sorry...this ndat file is of version = %s\n",hdr->id);
         printf("     ...version = %s expected !!!\n",DAT_ID_V3);
         return BAD_VERSION;}
     return NO_ERROR;
    }

 return err;
}

rd_output_slice_rois(fid,slice_rois,actual_total_slice_rois,
                     slice_nums,num_slice_rois)
 FILE *fid;
 struct slice_roi_rec **slice_rois;
 unsigned_int *slice_nums;
 unsigned_int actual_total_slice_rois,num_slice_rois;
{
 unsigned_int lcv;
 int err;

 TRACE(printf("rd_output_slice_rois...actual_total_slice_rois = %d num_slice_rois = %d\n",
             actual_total_slice_rois,num_slice_rois))
 if (num_slice_rois == 0) return NO_ERROR;
 if ((err = get_ptr(slice_rois,NULL,actual_total_slice_rois,
     (size_t) sizeof(struct slice_roi_rec))) != NO_ERROR)
    return err;

 for (lcv = 0; lcv < actual_total_slice_rois; lcv++)
    init_slice_roi_rec(&((*slice_rois)[lcv]));

 for (lcv = 0; lcv < num_slice_rois; lcv++)
    {TRACE(printf("reading slice# = %d slice num = %d\n",lcv,slice_nums[lcv]))
     if ((err = v3_rd_slice_roi_rec(fid,&((*slice_rois)[slice_nums[lcv]])))
          != NO_ERROR)
       {return err;}
    }
 TRACE(printf("rd_output_slice_rois...end\n"))
 return NO_ERROR;
}


rd_histo_pixel_center_recs(fid,centers,num_centers,slice_roi)
 FILE *fid;
 struct pixel_center_rec **centers;
 unsigned_int *num_centers;
 struct slice_roi_rec *slice_roi;
{
 unsigned_int lcv;
 char *str1,*str2;
 int err;

 TRACE(printf("rd_histo_pixel_center_recs...\n"))
 err = NO_ERROR;
 if (fread(num_centers,(size_t) sizeof(*num_centers),1,fid) == 1)
    {if (*num_centers == 0) return NO_ERROR;
     TRACE(printf("rd_histo_pixel_center_recs...1\n"))
     if ((err = get_ptr(centers,NULL,*num_centers,
                    (size_t) sizeof(struct pixel_center_rec))) != NO_ERROR)
        {*num_centers = 0;
         return err;}
     for (lcv = 0; lcv < *num_centers; lcv++)
        init_pixel_center_rec(&((*centers)[lcv]));

     TRACE(printf("rd_histo_pixel_center_recs...2\n"))
     for (lcv = 0; lcv < *num_centers; lcv++)
        {str1 = str2 = NULL;
         if (((err = rd_file_strs(fid,&str1,1)) != NO_ERROR) ||
             ((err = rd_file_strs(fid,&str2,1)) != NO_ERROR))
            break;
         if (fread(&((*centers)[lcv]),
                  (size_t) sizeof((*centers)[lcv]),1,fid) != 1)
            {err = READ_ERROR;
             break;}
         (*centers)[lcv].roi_label = str1;
         (*centers)[lcv].segmented_roi_label = str2;
        }
     if (err != NO_ERROR)
        {c_free(str1);
         c_free(str2);}
     TRACE(printf("rd_histo_pixel_center_recs...err = %d\n",err))
    }
   else return READ_ERROR;

     TRACE(printf("return rd_histo_pixel_center_recs...err = %d\n",err))

 return err;
}

rd_histo_bkg_rec(fid,bkg)
 FILE *fid;
 struct histo_bkg_rec *bkg;
{
 int err;

 TRACE(printf("rd_bkgs .........\n"))
 if (fread(&(bkg->num_bkgs),(size_t) sizeof(bkg->num_bkgs),1,fid) != 1)
    {bkg->num_bkgs = 0;
     return READ_ERROR;}
 TRACE(printf("rd_bkgs num_bkgs = %d\n",bkg->num_bkgs))
 if (bkg->num_bkgs == 0) return NO_ERROR;
 if ((err = get_ptr(&(bkg->bkgs),NULL,bkg->num_bkgs,
      (size_t) sizeof(*(bkg->bkgs)))) != NO_ERROR)
    {bkg->num_bkgs = 0;
     return err;}

 if (fread(bkg->bkgs,
         (size_t) (bkg->num_bkgs * sizeof(*(bkg->bkgs))),1,fid) != 1)
    {bkg->num_bkgs = 0;
     c_free(bkg->bkgs);
     return READ_ERROR;}
 TRACE(printf("rd_bkgs v3_rd_roi_rec\n"))
 err = v3_rd_roi_rec(fid,&(bkg->roi));
 TRACE(printf("rd_bkgs v3_rd_roi_rec err = %d\n",err))
 return err;
}

rd_histo_params(fid,histo)
 FILE *fid;
 struct histo_params_rec *histo;
{
 int err;

 TRACE(printf("rd_histo_params...1\n"))
 if (fread(&(histo->status2),(size_t) sizeof(histo->status2),1,fid) != 1)
    return READ_ERROR;
 PRT2(printf("rd_histo_params status2 = %x\n",(unsigned long) histo->status2);)

 if (histo->status2 & HISTO_TYPE)
    {if (((err = v3_rd_slice_roi_rec(fid,
              &(histo->slice_roi_win_2d.slice_roi))) != NO_ERROR) ||
         ((err = v3_rd_slice_roi_rec(fid,
              &(histo->slice_roi_win_1d.slice_roi))) != NO_ERROR) ||
         ((err = rd_histo_bkg_rec(fid,&(histo->bkg))) != NO_ERROR) ||
         ((err = rd_strs_rec(fid,&(histo->pixel_type_order))) != NO_ERROR))
        return err;
    }
   else err = NO_ERROR;
 if (histo->status2 & HISTO_CNT_1D_VALID)
    err = v3_rd_non_contiguos_buf_2d_rec(fid,&(histo->histo_1d));
 PRT2(printf("rd_histo_params...\n"))
 return err;

}

rd_pixel_type_cnt_rec(fid,pixel_cnt)
 FILE *fid;
 struct pixel_type_cnt_rec *pixel_cnt;
{
 int err;

 TRACE(printf("rd_pixel_type_cnt_rec...begin\n"))
 if ((fread(&(pixel_cnt->status),
        (size_t) sizeof(pixel_cnt->status),1,fid) != 1) ||
     (fread(&(pixel_cnt->num_pixel_type_cnts),
             sizeof(pixel_cnt->num_pixel_type_cnts),1,fid) != 1))
     return READ_ERROR;
 if ((err = get_ptr(&(pixel_cnt->pixel_type_cnts),NULL,
               (unsigned_int) pixel_cnt->num_pixel_type_cnts,
               (size_t) sizeof(unsigned_int))) != NO_ERROR)
    {pixel_cnt->num_pixel_type_cnts = 0;
     return err;}

 if (fread(pixel_cnt->pixel_type_cnts,
       (size_t) (pixel_cnt->num_pixel_type_cnts * sizeof(unsigned_int)),
            1,fid) != 1)
     return READ_ERROR;
 TRACE(printf("rd_pixel_type_cnt_rec...end\n"))

 return NO_ERROR;
}

rd_roi_pixel_type_cnts(fid,slice_rois,num_slice_rois)
 FILE *fid;
 struct slice_roi_rec *slice_rois;
 unsigned_int num_slice_rois;
{
 unsigned_int lcv,indx,loop,num_slices,num_rois,where;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 char *str;
 int err;

 TRACE(printf("rd_roi_pixel_type_cnts...begin\n"))
 if (fread(&num_slices,
        (size_t) sizeof(num_slices),1,fid) != 1) return READ_ERROR;
 if (num_slices == 0) return NO_ERROR;
 TRACE(printf("rd_roi_pixel_type_cnts...num_slices = %d\n",num_slices))
 for (indx = 0; indx < num_slices; indx++)
    {
     if (fread(&lcv,(size_t) sizeof(lcv),1,fid) != 1) return READ_ERROR;
     slice_roi = &(slice_rois[lcv]);

     if (fread(&num_rois,
         (size_t) sizeof(num_rois),1,fid) != 1) return READ_ERROR;
     TRACE(printf("rd_roi_pixel_type_cnts...lcv = %d num_rois = %d\n",lcv,num_rois))
     for (loop = 0; loop < num_rois; loop++)
        {
         if ((err = rd_file_strs(fid,&str,1)) != NO_ERROR) return err;
         roi = get_roi(slice_roi,str);
         c_free(str);
         if (roi == NULL)
            {
             return CANCEL;}
         if (roi->user.ptr != NULL) exit_pixel_type_cnt_rec(&(roi->user.ptr));
         init_user_defined_rec(&(roi->user));

         roi->user.exit = exit_pixel_type_cnt_rec;
         if ((err = get_ptr(&(roi->user.ptr),NULL,(unsigned_int) 1,
               (size_t) sizeof(struct pixel_type_cnt_rec))) != NO_ERROR)
            {free_user_defined_rec(&(roi->user));
             return err;}

         init_pixel_type_cnt_rec(roi->user.ptr);
         if ((err = rd_pixel_type_cnt_rec(fid,roi->user.ptr)) != NO_ERROR)
            {free_user_defined_rec(&(roi->user));
             return err;}
        }
     TRACE(printf("rd_roi_pixel_type_cnts...end loop = %d\n",num_rois))
    }
 TRACE(printf("rd_roi_pixel_type_cnts...end\n"))

 return NO_ERROR;
}

rd_pixel_type_params(fid,pixel_type)
 FILE *fid;
 struct pixel_type_rec *pixel_type;
{
 int err;

 TRACE(printf("rd_pixel_type_params...begin\n"))
 if (fread(&(pixel_type->status),
        (size_t) sizeof(pixel_type->status),1,fid) != 1)
    return READ_ERROR;
 PRT3(printf("rd_pixel_type_params...pixel_type->status = %x\n",
       (unsigned long) pixel_type->status))
 if (((err = rd_strs_rec(fid,&(pixel_type->order))) != NO_ERROR) ||
     ((err = rd_file_strs(fid,&(pixel_type->slice_map_data_creation_date),1
            )) != NO_ERROR) ||
     ((err = v3_rd_buf_2d_rec(fid,&(pixel_type->map))) != NO_ERROR))
    return err;

 if ((pixel_type->order.num_strs > 0) &&
     (pixel_type->map.status4 & BUF_DATA_VALID))
    {if (!(pixel_type->status & PIXEL_TYPE_SEGMENTED))
        pixel_type->status |= PIXEL_TYPE_2D_PARTITION;
    }
 TRACE(pr_strs_rec(&(pixel_type->order)))
 TRACE(printf("rd_pixel_type_params...err = %d\n",err))
 return err;
}
/*
 be careful that it is slice_rois[1..actual_total_slice_rois - 1]
 err = rd_roi_pixel_type_cnts(fid,slice_rois,num_slice_rois);
*/

rd_text_output_analysis_group_rec(fid,group)
 FILE *fid;
 struct text_output_analysis_group_rec *group;
{
 unsigned_int lcv;
 int err;

 if (fread(&(group->num_rois),(size_t) sizeof(group->num_rois),1,fid) != 1)
    return READ_ERROR;
 if (group->num_rois == 0) return NO_ERROR;

 if ((err = get_ptr(&(group->roi_labels),NULL,group->num_rois,
        (size_t) sizeof(char *))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < group->num_rois; lcv++)
    group->roi_labels[lcv] = NULL;

 if ((err = rd_file_strs(fid,group->roi_labels,group->num_rois)) != NO_ERROR)
    return err;

 if (fread(&(group->num_pixel_types),
      (size_t) sizeof(group->num_pixel_types),1,fid) != 1) return READ_ERROR;
 if (group->num_pixel_types == 0) return NO_ERROR;
 if ((err = get_ptr(&(group->pixel_type_labels),NULL,group->num_pixel_types,
        (size_t) sizeof(char *))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < group->num_pixel_types; lcv++)
    group->pixel_type_labels[lcv] = NULL;

 if ((err = rd_file_strs(fid,group->pixel_type_labels,group->num_pixel_types))
        != NO_ERROR) return READ_ERROR;
 return NO_ERROR;
}

rd_input_text_file_format(fid,groups,num_groups)
 FILE *fid;
 struct text_output_analysis_group_rec **groups;
 unsigned_int *num_groups;
{
 unsigned_int lcv;
 int err;

 TRACE(printf("rd_input_text_file_format...begin\n"))
 if (fread(num_groups,(size_t) sizeof(*num_groups),1,fid) != 1)
    {*num_groups = 0;
     *groups = NULL;
     return READ_ERROR;}
 if (*num_groups <= 0)
    {*groups = NULL;
     return NO_ERROR;}
 TRACE(printf("rd_input_text_file_format...*num_groups = %d\n",*num_groups))

 if ((err = get_ptr(groups,NULL,(unsigned_int) *num_groups,
        (size_t) sizeof(struct text_output_analysis_group_rec))) != NO_ERROR)
    {*num_groups = 0;
     return err;}

 for (lcv = 0; lcv < *num_groups; lcv++)
    init_text_output_analysis_group_rec(&((*groups)[lcv]));

 for (lcv = 0; lcv < *num_groups; lcv++)
    if ((err = rd_text_output_analysis_group_rec(fid,&((*groups)[lcv])))
           != NO_ERROR)
        return err;

 return NO_ERROR;
}

rd_output_field_rec(fid,group)
 FILE *fid;
 struct output_field_rec *group;
{
 int err;

 TRACE(printf("rd_output_field_rec...begin\n"))
 if ((fread(&(group->pixel_type_indx),(size_t) sizeof(group->pixel_type_indx),
              1,fid) != 1) ||
     (fread(&(group->num_roi_indxs),(size_t) sizeof(group->num_roi_indxs),
              1,fid) != 1))
    {group->num_roi_indxs = 0;
     return READ_ERROR;}

 TRACE(printf("group->pixel_type_indx = %d group->num_roi_indxs = %d\n",
       group->pixel_type_indx,group->num_roi_indxs))
 if (group->num_roi_indxs > 0)
    {if ((err = get_ptr(&(group->roi_indxs),NULL,group->num_roi_indxs,
          (size_t) sizeof(*(group->roi_indxs)))) != NO_ERROR)
        {group->num_roi_indxs = 0;
         return err;}
     if (fread(group->roi_indxs,(size_t) sizeof(*(group->roi_indxs)) *
              group->num_roi_indxs,1,fid) != 1)
        return READ_ERROR;
    }
 return NO_ERROR;
}

rd_output_count_field_rec(fid,group)
 FILE *fid;
 struct output_count_field_rec *group;
{
 int err;

 if (fread(&(group->num_fields),(size_t) sizeof(group->num_fields),1,fid) != 1)
    {group->num_fields = 0;
     return READ_ERROR;}
 if (group->num_fields > 0)
    {
     if ((err = get_ptr(&(group->fields),NULL,group->num_fields,
               (size_t) sizeof(*(group->fields)))) != NO_ERROR)
        {group->num_fields = 0;
         return err;}
     if (fread(group->fields,(size_t) sizeof(*(group->fields)) *
              group->num_fields,1,fid) != 1)
        return READ_ERROR;
    }
 return NO_ERROR;

}

rd_output_count_group_rec(fid,count)
 FILE *fid;
 struct output_count_group_rec *count;
{
 unsigned_int lcv;
 int err;

 if (fread(&(count->num_groups),(size_t) sizeof(count->num_groups),1,fid) != 1)
    {count->num_groups = 0;
     return READ_ERROR;}
 if (count->num_groups > 0)
    {if ((err = get_ptr(&(count->groups),NULL,count->num_groups,
               (size_t) sizeof(*(count->groups)))) != NO_ERROR)
        {count->num_groups = 0;
         return err;}
     for (lcv = 0; lcv < count->num_groups; lcv++)
        if ((err = rd_output_count_field_rec(fid,&(count->groups[lcv])))
               != NO_ERROR)
           return err;
    }
 return NO_ERROR;
}

rd_output_text_file_format(fid,format)
 FILE *fid;
 struct output_text_format_rec *format;
{
 unsigned_int lcv;
 int err;

 TRACE(printf("rd_output_text_file_format...begin\n"))
 if (fread(&(format->status),(size_t) sizeof(format->status),1,fid) != 1)
    return READ_ERROR;
 if (!(format->status & OUT_FORMAT_DEFINED)) 
    {TRACE(printf("rd !(status & OUT_FORMAT_DEFINED)\n"))
     free_output_text_format_rec(format);
     return NO_ERROR;}
 if ((err = rd_strs_rec(fid,&(format->roi_labels))) != NO_ERROR)
    return err;

 if (format->roi_labels.num_strs > 0)
    {if ((err = get_ptr(&(format->roi_nums),NULL,format->roi_labels.num_strs,
          (size_t) sizeof(*(format->roi_nums)))) != NO_ERROR)
        return err;
     if (fread(format->roi_nums,(size_t) sizeof(*(format->roi_nums)) *
              format->roi_labels.num_strs,1,fid) != 1)
        return READ_ERROR;
    }

 if ((err = rd_strs_rec(fid,&(format->pixel_type_labels))) != NO_ERROR)
    return err;
 if (format->pixel_type_labels.num_strs > 0)
    {if ((err = get_ptr(&(format->pixel_type_nums),NULL,
                format->pixel_type_labels.num_strs,
               (size_t) sizeof(*(format->pixel_type_nums)))) != NO_ERROR)
        return err;
     if (fread(format->pixel_type_nums,(size_t)
           sizeof(*(format->pixel_type_nums)) *
              format->pixel_type_labels.num_strs,1,fid) != 1)
        return READ_ERROR;
    }

 if (fread(&(format->num_groups),
           (size_t) sizeof(format->num_groups),1,fid) != 1)
    return READ_ERROR;

 if (format->num_groups > 0)
    {if ((err = get_ptr(&(format->groups),NULL,format->num_groups,
               (size_t) sizeof(*(format->groups)))) != NO_ERROR)
        {format->num_groups = 0;
         return err;}
     for (lcv = 0; lcv < format->num_groups; lcv++)
        if ((err = rd_output_field_rec(fid,&(format->groups[lcv])))
             != NO_ERROR) return err;
    }

 if (fread(&(format->num_slices),(size_t) sizeof(format->num_slices),
              1,fid) != 1)
    return READ_ERROR;
 if (format->num_slices > 0)
    {if ((err = get_ptr(&(format->counts),NULL,format->num_slices,
               (size_t) sizeof(*(format->counts)))) != NO_ERROR)
        {format->num_slices = 0;
         return err;}
     for (lcv = 0; lcv < format->num_slices; lcv++)
        if ((err = rd_output_count_group_rec(fid,&(format->counts[lcv])))
           != NO_ERROR) return err;
    }

 if ((fread(&(format->page_num_rows),(size_t) sizeof(format->page_num_rows),
              1,fid) != 1) ||
     (fread(&(format->page_row_size),(size_t) sizeof(format->page_row_size),
              1,fid) != 1) ||
     (fread(&(format->num_field_spaces),
         sizeof(format->num_field_spaces),1,fid) != 1) ||
     (fread(&(format->num_collect_spaces),
         sizeof(format->num_collect_spaces),1,fid) != 1) ||
     (fread(&(format->xpixel_size),(size_t) sizeof(format->xpixel_size),1,fid)
             != 1) ||
     (fread(&(format->ypixel_size),(size_t) sizeof(format->ypixel_size),1,fid)
             != 1) ||
     (fread(&(format->pixel_thickness),
         sizeof(format->pixel_thickness),1,fid) != 1) ||
     (fread(&(format->voxel_size),(size_t) sizeof(format->voxel_size),1,fid)
             != 1))
    return READ_ERROR;

 if (format->status & OUT_FORMAT_LT_PERCENT_MEAN)
    {PRT5(printf("OUT_FORMAT_LT_PERCENT_MEAN...\n"))
     if (fread(&(format->lt_percent),
              (size_t) sizeof(format->lt_percent),1,fid) != 1)
        return READ_ERROR;
    }
 if (format->status & OUT_FORMAT_GT_PERCENT_MEAN)
    {PRT5(printf("OUT_FORMAT_GT_PERCENT_MEAN...\n"))
     if (fread(&(format->gt_percent),
              (size_t) sizeof(format->gt_percent),1,fid) != 1)
        return READ_ERROR;
    }
 if (format->status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    {PRT5(printf("OUT_FORMAT_LT_PERCENT_ROI_MEAN...\n"))
     if (fread(&(format->roi_lt_percent),
              (size_t) sizeof(format->roi_lt_percent),1,fid) != 1)
        return READ_ERROR;
    }
 if (format->status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    {PRT5(printf("OUT_FORMAT_GT_PERCENT_ROI_MEAN...\n"))
     if (fread(&(format->roi_gt_percent),
              (size_t) sizeof(format->roi_gt_percent),1,fid) != 1)
        return READ_ERROR;
    }

 if (!(format->status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
     (format->status & OUT_FORMAT_UNIT_2D_VALID))
    {PRT5(printf("OUT_FORMAT_UNIT_2D_VALID...\n"))
     if (fread(&(format->img_unit),
              (size_t) sizeof(format->img_unit),1,fid) != 1)
        return READ_ERROR;
    }
 TRACE(printf("rd_output_text_file_format...end\n"))
 return NO_ERROR;
}

/*
old struct roi_count_anal_rec
   {char *label;
    long min,max;
    unsigned long num_pixels;
    double total_counts,sd;
   };
*/
rd_roi_count_anal_rec(fid,roi,is_new_format)
 FILE *fid;
 struct roi_count_anal_rec *roi;
{
 int err;
 long min,max;

 PRT5(printf("rd_roi_count_anal_rec...\n"))
 if ((err = rd_file_strs(fid,&(roi->label),1)) != NO_ERROR)
    return err;
 if (!is_new_format)
    {if ((fread(&min,(size_t) sizeof(min),1,fid) != 1) ||
         (fread(&max,(size_t) sizeof(max),1,fid) != 1))
        return READ_ERROR;
     roi->min = min;
     roi->max = max;
    }
   else
    {if ((fread(&(roi->status2),(size_t) sizeof(roi->status2),1,fid) != 1) ||
         (fread(&(roi->min),(size_t) sizeof(roi->min),1,fid) != 1) ||
         (fread(&(roi->max),(size_t) sizeof(roi->max),1,fid) != 1))
        return READ_ERROR;
    }
 if ((fread(&(roi->num_pixels),(size_t) sizeof(roi->num_pixels),1,fid) != 1) ||
     (fread(&(roi->total_counts),(size_t) sizeof(roi->total_counts),1,fid) != 1) ||
     (fread(&(roi->sd),(size_t) sizeof(roi->sd),1,fid) != 1))
    return READ_ERROR;

 if (is_new_format)
    if ((fread(&(roi->cnt_neg_val),
              (size_t) sizeof(roi->cnt_neg_val),1,fid) != 1) ||
        (fread(&(roi->cnt_smean_min_rej),
              (size_t) sizeof(roi->cnt_smean_min_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_smean_max_rej),
              (size_t) sizeof(roi->cnt_smean_max_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_rmean_min_rej),
              (size_t) sizeof(roi->cnt_rmean_min_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_rmean_max_rej),
              (size_t) sizeof(roi->cnt_rmean_max_rej),1,fid) != 1) ||
        (fread(&(roi->slice_mean),(size_t) sizeof(roi->slice_mean),1,fid) != 1) ||
        (fread(&(roi->min_smean_threshold),
             (size_t) sizeof(roi->min_smean_threshold),1,fid) != 1) ||
        (fread(&(roi->max_smean_threshold),
             (size_t) sizeof(roi->max_smean_threshold),1,fid) != 1) ||
        (fread(&(roi->roi_mean),(size_t) sizeof(roi->roi_mean),1,fid) != 1) ||
        (fread(&(roi->min_rmean_threshold),
             (size_t) sizeof(roi->min_rmean_threshold),1,fid) != 1) ||
        (fread(&(roi->max_rmean_threshold),
             (size_t) sizeof(roi->max_rmean_threshold),1,fid) != 1))
       return READ_ERROR;
 PRT5(pr_roi_count_anal_rec(roi);)
/*
 PRT5(printf("min = %f max = %f num_pixels = %d total_counts = %f sd = %f\n",
        roi->min,roi->max,roi->num_pixels,roi->total_counts,roi->sd))
*/
 return NO_ERROR;
}

rd_slice_count_anal_rec(fid,slice)
 FILE *fid;
 struct slice_count_anal_rec *slice;
{
 int err;
 unsigned long lcv,total,temp;
 int is_new_format;

 PRT5(printf("rd_slice_count_anal_rec...\n"))
 free_slice_count_anal_rec(slice);
 if ((fread(&(slice->status1),(size_t) sizeof(slice->status1),1,fid) != 1) ||
     (fread(&(slice->num_rois),(size_t) sizeof(slice->num_rois),1,fid) != 1))
    return READ_ERROR;
 PRT5(printf("rd_slice_count_anal_rec...1\n"))

 if (slice->num_rois == 0) return NO_ERROR;
 if (slice->num_rois > slice->total_rois)
    {total = slice->num_rois - slice->total_rois;
     temp = slice->total_rois;
     if ((err = get_ptr(&(slice->rois),&(slice->total_rois),total,
                 (size_t) sizeof(*(slice->rois)))) != NO_ERROR)
        {slice->num_rois = 0;
         return err;}
    }
 for (lcv = 0; lcv < slice->num_rois; lcv++)
    init_roi_count_anal_rec(&(slice->rois[lcv]));

 is_new_format = slice->status1 & COUNT_NEW_FORMAT;
 for (lcv = 0; lcv < slice->num_rois; lcv++)
    if ((err = rd_roi_count_anal_rec(fid,&(slice->rois[lcv]),
             is_new_format)) != NO_ERROR)
       return err;
 return NO_ERROR;
}

rd_slice_count_anal_recs(fid,slices,total_slices,num_slices)
 FILE *fid;
 struct slice_count_anal_rec **slices;
 unsigned long *total_slices,*num_slices;
{
 unsigned long lcv,total,temp;
 int err;

 PRT5(printf("rd_slice_count_anal_recs...\n"))
 if (fread(num_slices,(size_t) sizeof(*num_slices),1,fid) != 1)
    return WRITE_ERROR;
 PRT5(printf("*num_slices = %d...*total_slices = %d\n",*num_slices,*total_slices))
 if (*num_slices <= 0) return NO_ERROR;
 if (*num_slices > *total_slices)
    {total = *num_slices - *total_slices;
     temp = *total_slices;
     if ((err = get_ptr(slices,total_slices,total,
                 (size_t) sizeof(**(slices)))) != NO_ERROR)
        {*num_slices = 0;
         return err;}
     for (lcv = temp; lcv < *total_slices; lcv++)
        init_slice_count_anal_rec(&((*slices)[lcv]));}

 for (lcv = 0; lcv < *num_slices; lcv++)
    if ((err = rd_slice_count_anal_rec(fid,&((*slices)[lcv]))) != NO_ERROR) 
       return err;
 PRT5(printf("rd_slice_count_anal_recs...end\n"))
 return NO_ERROR;
}

rd_count_analysis_rec(fid,count)
 FILE *fid;
 struct count_analysis_rec *count;
{
 int err;
 unsigned long lcv;

 PRT5(printf("rd_count_analysis_rec...\n"))
 if (count == NULL) return NO_ERROR;
 if (((err = rd_input_text_file_format(fid,&(count->groups),
              &(count->num_groups))) != NO_ERROR) ||
     ((err =  rd_output_text_file_format(fid,
            &(count->format))) != NO_ERROR))
   return err;
 if (count->format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
    if (fread(&(count->echo_num),(size_t) sizeof(count->echo_num),1,fid) != 1)
       return READ_ERROR;

 count->out_format_status = count->format.status;
 if (count->out_format_status & OUT_FORMAT_LT_PERCENT_MEAN)
    count->lt_percent = count->format.lt_percent;
 if (count->out_format_status & OUT_FORMAT_GT_PERCENT_MEAN)
    count->gt_percent = count->format.gt_percent;

 if (count->out_format_status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    count->roi_lt_percent = count->format.roi_lt_percent;
 if (count->out_format_status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    count->roi_gt_percent = count->format.roi_gt_percent;
 if (count->out_format_status & OUT_FORMAT_UNIT_2D_VALID)
    count->img_unit = count->format.img_unit;
 if (count->num_slices > 0)
    {for (lcv = 0; lcv < count->num_slices; lcv++)
        free_slice_count_anal_rec(&(count->slices[lcv]));
     count->num_slices = 0;}
 PRT5(printf("rd_count_analysis_rec...1\n"))

 return rd_slice_count_anal_recs(fid,&(count->slices),
            &(count->total_slices),&(count->num_slices));
}

cp_dat_output_hdr_rec(hdr,output)
 struct output_hdr_rec *hdr;
 struct output_file_rec *output;
{
 free_output_hdr_rec(&(output->hdr));
 memcpy(&(output->hdr),hdr,(size_t) sizeof(struct output_hdr_rec));
 hdr->info.status |= OUTPUT_HDR_INFO_REC_SETUP;
 return NO_ERROR;
}

cp_dat_slice_roi_recs(slice_rois,slice_nums,num_slice_rois,
                      actual_total_slice_rois,file)
 struct slice_roi_rec *slice_rois;
 unsigned_int *slice_nums,num_slice_rois,actual_total_slice_rois;
 struct input_file_rec *file;
{
 unsigned long add,temp,lcv;
 int err;

 TRACE(printf("cp_dat_slice_roi_recs max = %d num = %d actual_total_slice_rois = %d\n",
      file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins,
      actual_total_slice_rois);)

 for (lcv = 0; lcv < file->slice_info.max_sroi_wins; lcv++)
    free_slice_roi_rec(&(file->slice_info.sroi_wins[lcv]->slice_roi));
 if (num_slice_rois == 0) return NO_ERROR;

 if (file->slice_info.max_sroi_wins < actual_total_slice_rois)
    {add = actual_total_slice_rois - file->slice_info.max_sroi_wins;
     temp = file->slice_info.max_sroi_wins;
     TRACE(printf("max = %d num = %d add = %d actual_total_slice_rois = %d\n",
      file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins,
      add,actual_total_slice_rois))
     if ((err = get_handle(&(file->slice_info.sroi_wins),
           &(file->slice_info.max_sroi_wins),
           add,(size_t) sizeof(**(file->slice_info.sroi_wins)))) != NO_ERROR)
        return err;
     for (lcv = temp; lcv < file->slice_info.max_sroi_wins; lcv++)
        init_slice_roi_win_rec(file->slice_info.sroi_wins[lcv],
             file->hdr.data_info.dimx,file->hdr.data_info.dimy);
     AssociateSlicesWithSliceRoiWinRecs(&(file->hdr),
        file->hdr.scans,file->hdr.num_scans,
        file->slice_info.sroi_wins,file->slice_info.num_sroi_wins);
    }
 for (lcv = 0; lcv < num_slice_rois; lcv++)
    {              
     if (slice_nums[lcv] < file->slice_info.max_sroi_wins)
        {
         file->slice_info.sroi_wins[slice_nums[lcv]]->slice_roi
              = slice_rois[slice_nums[lcv]];
        }
    }
/*
 for (lcv = 0; lcv < file->slice_info.max_sroi_wins; lcv++)
    printf("cp_dat_slice_roi_recs out %d) %u num_wins = %d\n",lcv,file->slice_info.sroi_wins[lcv],
        file->slice_info.sroi_wins[lcv]->num_wins);
*/
 TRACE(printf("cp_dat_slice_roi_recs...end\n"))
 return NO_ERROR;

}

cp_nth_slice_roi_rec(slice_rois,slice_nums,num_slice_rois,file,slice_num)
 struct slice_roi_rec *slice_rois;
 unsigned_int *slice_nums,num_slice_rois;
 struct input_file_rec *file;
 long slice_num;
{
 unsigned long add,temp,lcv;
 int err;

 PRT1(printf("cp_nth_slice_roi_rec max = %d num = %d\n",
      file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins))

 if (slice_num < file->slice_info.max_sroi_wins)
    {free_slice_roi_rec(&(file->slice_info.sroi_wins[slice_num]->slice_roi));
     if (num_slice_rois == 0) return NO_ERROR;

     for (lcv = 0; lcv < num_slice_rois; lcv++)
        {              
         if (slice_nums[lcv] == slice_num)
            {
             file->slice_info.sroi_wins[slice_num]->slice_roi = slice_rois[slice_num];
             init_slice_roi_rec(&(slice_rois[slice_num]));
             return NO_ERROR;
            }
        }
    }
 PRT1(printf("cp_nth_slice_roi_rec...end\n"))
 return NO_ERROR;

}

cp_dat_histo_params_rec(histo,file)
 struct histo_params_rec *histo;
 struct input_file_rec *file;
{
 unsigned_int num_wins,num_wins1;
 struct image_display_window **wins,**wins1;
/*
 printf("histo->bkg.num_bkgs = %d\n",histo->bkg.num_bkgs);
 printf("file->hdr.data_info.num_echoes = %d\n",file->hdr.data_info.num_echoes);
*/
 if (histo->bkg.num_bkgs > 0)
    {
     if (((file->hdr.data_info.num_echoes == 1) && 
          (file->hdr.data_info.num_echoes != histo->bkg.num_bkgs)) ||
         ((file->hdr.data_info.num_echoes == 2) && 
          (histo->bkg.num_bkgs != 4)))
        {if (((file->hdr.data_info.num_echoes == 1) &&
              !(file->histo_params.status2 & HISTO_1D)) ||
             ((file->hdr.data_info.num_echoes == 2) &&
              !(file->histo_params.status2 & HISTO_MULTI_D)))
            {
             free_histo_params_rec(histo);
             free_histo_params_rec(&(file->histo_params));
             return NO_ERROR;}
         if (file->hdr.data_info.num_echoes == 1) 
            free_histo_pixel_center_rec(histo);
           else free_histo_pixel_tissue_type_rec(histo);
         free_histo_bkg_rec(&(histo->bkg));
        }
    }
/*
 printf("===histo->bkg.num_bkgs = %d\n",histo->bkg.num_bkgs);
*/
 num_wins = file->histo_params.slice_roi_win_2d.num_wins;
 wins = file->histo_params.slice_roi_win_2d.wins;
 num_wins1 = file->histo_params.slice_roi_win_1d.num_wins;
 wins1 = file->histo_params.slice_roi_win_1d.wins;
 file->histo_params.slice_roi_win_2d.num_wins = 0;
 file->histo_params.slice_roi_win_1d.num_wins = 0;
 file->histo_params.slice_roi_win_2d.wins = NULL;
 file->histo_params.slice_roi_win_1d.wins = NULL;

 free_histo_params_rec(&(file->histo_params));

 memcpy(&(file->histo_params),histo,(size_t) sizeof(struct histo_params_rec));
/*
 printf("===file->histo->bkg.num_bkgs = %d\n",file->histo_params.bkg.num_bkgs);
*/
 file->histo_params.slice_roi_win_2d.num_wins = num_wins;
 file->histo_params.slice_roi_win_2d.wins = wins;
 file->histo_params.slice_roi_win_1d.num_wins = num_wins1;
 file->histo_params.slice_roi_win_1d.wins = wins1;
 file->histo_params.file = file;
/* file->histo_params.status2 = 
           (unsigned short) file_get_def_histo_type(file); */

 return NO_ERROR;
}

cp_dat_pixel_type_rec(pixel_type,file)
 struct pixel_type_rec *pixel_type;
 struct input_file_rec *file;
{
 TRACE(printf("cp_dat_pixel_type_rec...file = %u  pixel_type = %u\n",
           file,pixel_type))

 free_pixel_type_rec(&(file->pixel_type));
 TRACE(printf("cp_dat_pixel_type_rec...file->pixel_type = %u\n",
          &(file->pixel_type)))
 memcpy(&(file->pixel_type),pixel_type,
         (size_t) sizeof(struct pixel_type_rec));
 TRACE(printf("cp_dat_pixel_type_rec...3\n"))

 return NO_ERROR;
}

cp_text_output_analysis_group_rec(groups,num_groups,file)
 struct text_output_analysis_group_rec *groups;
 unsigned_int num_groups;
 struct input_file_rec *file;
{
 TRACE(printf("cp_text_output_analysis_group_rec...\n"))
 free_analysis_group_recs(file->text.groups,file->text.num_groups);
 file->text.num_groups = num_groups;
 file->text.groups = groups;
 if (num_groups > 0)
    file->text.status |= TEXT_OUTPUT_FORMAT_SETUP;
   else file->text.status &= ~TEXT_OUTPUT_FORMAT_SETUP;
 TRACE(printf("cp_text_output_analysis_group_rec...end\n"))
 return NO_ERROR;
}

cp_output_text_format_rec(format,file)
 struct output_text_format_rec *format;
 struct input_file_rec *file;
{
 free_output_text_format_rec(&(file->text.format));
 TRACE(pr_output_text_format_rec(format);)
 file->text.format = *format;
}

cp_count_analysis_rec(count,file)
 struct count_analysis_rec *count;
 struct input_file_rec *file;
{
 free_count_analysis_rec(&(file->count));
 file->count = *count;
 file->count.file = file;
}

hdr_error_proc()
{

}

RdNdatFields(fid,hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)
 FILE *fid;
 struct output_hdr_rec *hdr;
 struct slice_roi_rec **slice_rois;
 long *total_slice_rois;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_analysis_group_rec **groups;
 unsigned_int *num_groups;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
{
 int err;

 TRACE(printf("RdNdatFields...\n"))
 if ((err = rd_output_hdr_rec(fid,hdr,hdr_error_proc)) != NO_ERROR)
    return err;
 if (slice_rois != NULL)
    {fseek(fid,hdr->offset.slice_roi_start,0);
     if ((fread(&(hdr->actual_total_slice_rois),
             sizeof(hdr->actual_total_slice_rois),1,fid) != 1) ||
         (fread(&(hdr->num_slice_rois),
           (size_t) sizeof(hdr->num_slice_rois),1,fid) != 1) ||
         ((err = rd_output_slice_nums(fid,&(hdr->slice_nums),
                   &(hdr->num_slice_rois))) != NO_ERROR) ||
         ((err = rd_output_slice_rois(fid,slice_rois,
            hdr->actual_total_slice_rois,hdr->slice_nums,hdr->num_slice_rois))
                   != NO_ERROR))
        return err;
     *total_slice_rois = hdr->actual_total_slice_rois;
    }
 TRACE(printf("RdNdatFields...1\n"))
 if ((histo != NULL) && (hdr->offset.histo_params_size > 0))
    {fseek(fid,hdr->offset.histo_params_start,0);
     if ((err = rd_histo_params(fid,histo)) != NO_ERROR) return err;
    }
 if ((pixel_type != NULL) && (hdr->offset.pixel_type_params_size > 0))
    {fseek(fid,hdr->offset.pixel_type_params_start,0);
     if ((err = rd_pixel_type_params(fid,pixel_type)) != NO_ERROR)
       return err;
    }
 TRACE(printf("RdNdatFields...text_format_start = %d text_format_size = %d\n",hdr->offset.text_format_start,
              hdr->offset.text_format_size))
 if ((format != NULL) && (hdr->offset.text_format_size > 0))
    {fseek(fid,hdr->offset.text_format_start,0);
     if ((err = rd_input_text_file_format(fid,groups,num_groups)) !=
            NO_ERROR)
        return err;
     if ((err = rd_output_text_file_format(fid,format)) != NO_ERROR) return err;
    }

 PRT5(printf("RdNdatFields...count_start = %d count_size = %d\n",hdr->offset.count_start,hdr->offset.count_size))
 if ((count != NULL) && (hdr->offset.count_size > 0))
    {fseek(fid,hdr->offset.count_start,0);
     if ((err = rd_count_analysis_rec(fid,count)) != NO_ERROR)
        return err;
    }

 TRACE(printf("RdNdatFields...err = %d\n",err))
 return NO_ERROR;
}

free_ndat_fields(hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)
 struct output_hdr_rec *hdr;
 struct slice_roi_rec *slice_rois;
 long total_slice_rois;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_analysis_group_rec *groups;
 unsigned_int num_groups;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
{
 unsigned long lcv;

 if (hdr != NULL) free_output_hdr_rec(hdr);
 if (slice_rois != NULL)
    {for (lcv = 0; lcv < total_slice_rois; lcv++)
        free_slice_roi_rec(&(slice_rois[lcv]));
     c_free(slice_rois);}
 if (histo != NULL)
    free_histo_params_rec(histo);
 if (pixel_type != NULL)
    free_pixel_type_rec(pixel_type);
 if (groups != NULL)
    {free_analysis_group_recs(groups,num_groups);
     c_free(groups);}
 if (format != NULL)
    free_output_text_format_rec(format);
 if (count != NULL)
    free_count_analysis_rec(count);
}

RdTheNdatFields(fn,hdr,slice_rois,total_slice_rois,histo,pixel_type,
                   groups,num_groups,format,count)
 char *fn;
 struct output_hdr_rec *hdr;
 struct slice_roi_rec **slice_rois;
 long *total_slice_rois;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_analysis_group_rec **groups;
 unsigned_int *num_groups;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
{
 FILE *fid;
 int err;

 TRACE(printf("RdTheNdatFields...\n"))
 init_output_hdr_rec(hdr);
 if (slice_rois != NULL)
    {*total_slice_rois = 0;
     *slice_rois = NULL;}
 if (histo != NULL) init_histo_params_rec(histo,NULL);
 if (pixel_type != NULL) init_pixel_type_rec(pixel_type);
 if (format != NULL)
    {*num_groups = 0;
     *groups = NULL;
     init_output_text_format_rec(format);}

 if (count != NULL) init_count_analysis_rec(count,NULL);

 TRACE(printf("RdTheNdatFields...fn = %s\n",fn))
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 TRACE(printf("RdTheNdatFields...1\n"))
 fseek(fid,0,0);
 err = RdNdatFields(fid,hdr,slice_rois,total_slice_rois,
                   histo,pixel_type,groups,num_groups,format,count);
 TRACE(printf("RdTheNdatFields...err = %d...end\n",err))
 fclose(fid);
 return err;
}

rd_dat_file(fn,output)
 char *fn;
 struct output_file_rec *output;
{
 struct output_hdr_rec hdr;
 int err;
 struct slice_roi_rec *slice_rois;
 struct histo_params_rec histo;
 struct pixel_type_rec pixel_type;
 struct text_output_analysis_group_rec *groups;
 unsigned_int num_groups,lcv,cnt,total_slice_rois;
 struct output_text_format_rec format;
 struct count_analysis_rec count;

 TRACE(printf("rd_dat_file...\n"))
 if (((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
       &histo,&pixel_type,&groups,&num_groups,&format,&count)) != NO_ERROR) ||
     ((err = cp_dat_slice_roi_recs(slice_rois,hdr.slice_nums,hdr.num_slice_rois,
                   hdr.actual_total_slice_rois,output->file)) != NO_ERROR))
    {
     TRACE(printf("slice_rois = %d...actual_total_slice_rois = %d\n",
               slice_rois,hdr.actual_total_slice_rois))
     if (slice_rois != NULL)
        {TRACE(printf("rd_dat_file free slice_rois\n"))
         for (lcv = 0; lcv < hdr.actual_total_slice_rois; lcv++)
            free_slice_roi_rec(&(slice_rois[lcv]));
         c_free(slice_rois);}

     free_output_hdr_rec(&hdr);
     free_histo_params_rec(&histo);
     TRACE(printf("free_pixel_type_rec...begin\n"))

     free_pixel_type_rec(&pixel_type);
     TRACE(printf("...begin num_groups = %d\n",num_groups))
     for (lcv = 0; lcv < num_groups; lcv++)
        free_text_output_analysis_group_rec(&(groups[lcv]));
     c_free(groups);
     free_output_text_format_rec(&format);
     free_count_analysis_rec(&count);
    }
   else
    {TRACE(printf("cp_dat_output_hdr_rec...\n"))
     cp_dat_output_hdr_rec(&hdr,output);
     TRACE(printf("cp_dat_slice_roi_recs...\n"))
     TRACE(printf("cp_dat_histo_params_rec...\n"))
     c_free(slice_rois);
     cp_dat_histo_params_rec(&histo,output->file);
     TRACE(printf("cp_dat_pixel_type_rec...\n"))
     cp_dat_pixel_type_rec(&pixel_type,output->file);
     TRACE(printf("cp_text_output_analysis_group_rec...\n"))
     cp_text_output_analysis_group_rec(groups,num_groups,output->file);
     TRACE(printf("cp_output_text_format_rec...\n"))
     cp_output_text_format_rec(&format,output->file);
     TRACE(printf("cp_output_text_format_rec...end\n"))
     cp_count_analysis_rec(&count,output->file);
     TRACE(printf("cp_count_analysis_rec...end\n"))
    }

 TRACE(printf("rd_dat_file...end err = %d\n",err))
 return err;
}

rd_dat_file_slice_rois(fn,file)
 char *fn;
 struct input_file_rec *file;
{
 struct output_hdr_rec hdr;
 int err;
 struct slice_roi_rec *slice_rois;
 unsigned_int lcv,total_slice_rois;

 if (((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
            NULL,NULL,NULL,NULL,NULL,NULL)) != NO_ERROR) ||
     ((err = cp_dat_slice_roi_recs(slice_rois,hdr.slice_nums,hdr.num_slice_rois,
                   hdr.actual_total_slice_rois,file)) != NO_ERROR))
    {
     if (slice_rois != NULL)
        {for (lcv = 0; lcv < total_slice_rois; lcv++)
            free_slice_roi_rec(&(slice_rois[lcv]));
        }
    }
 free_output_hdr_rec(&hdr);
 c_free(slice_rois);

 return err;
}

rd_file_slice_roi_rec(fn,file,slice_num)
 char *fn;
 struct input_file_rec *file;
 long slice_num;
{
 struct output_hdr_rec hdr;
 int err;
 struct slice_roi_rec *slice_rois;
 unsigned_int lcv,total_slice_rois;

 PRT1(printf("rd_file_slice_roi_rec...\n"))
 if ((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
            NULL,NULL,NULL,NULL,NULL,NULL)) == NO_ERROR)
    err = cp_nth_slice_roi_rec(slice_rois,hdr.slice_nums,hdr.num_slice_rois,
                  file,slice_num);
 if (slice_rois != NULL)
    {for (lcv = 0; lcv < total_slice_rois; lcv++)
        free_slice_roi_rec(&(slice_rois[lcv]));
    }

 free_output_hdr_rec(&hdr);
 c_free(slice_rois);

 return err;
}
